#include <Servo.h> //include servo library and declare vairables for the pins
Servo myservo; 
int trig = 6;
int echo = 5; 
int servo = 9;
float distance;
int count = 0;

void setup()
{
  pinMode(echo, INPUT); //setup your pins 
  pinMode(trig, OUTPUT);
  myservo.attach(servo);
  Serial.begin(9600);
  myservo.write(110); //door stays closed at beginning
}

void loop() {
  distance = getdistance(trig, echo);

  Serial.print("Distance: "); //this is optional. having the serial prints helps to debugs and have a number for the distance
  Serial.println(distance);
  Serial.print("Count: ");
  Serial.println(count);

  delay(500); //this delay is crucial. Giving time for the sensor to pause avoids overloading the sensor with too many actions at once. 

  if (distance < 12) { //this detects for the hamster in the area. 
    count++; //add a count 

    if (count == 1) { //if there's a count the door opens. the distance must be less than 12 for a count to be added
      myservo.write(0); // Open door
    }

    while (getdistance(trig, echo) < 12) { //this while loop keeps the door open while the hamster is in the area. when the hamster goes out of range (inside or away from the sensor) the code returns to the top of the loop and detects again
      delay(200);
    }

    delay(1000); // Prevent double-counting
  }

  if (count >= 2) { //this detects for when the hamster crosses and second time. If the hamster is detected once and goes inside the room, the door must stay open while it's inside. This if statement detects for a second pass (theoretically the hamster leaves the room) which closes the door. 
    myservo.write(110); // Close door
    count = 0; //restart the count to have the code reset
  }
}


//distance sensor function
float getdistance(int trig, int echo)
{
float echoTime; //variable to store the time it takes for a ping to bounce off an object
float calculatedDistance; //variable to store the distance calculated from the echo time
//send out an ultrasonic pulse that's 10ms long
digitalWrite(trig, HIGH);
delayMicroseconds(10);
digitalWrite(trig, LOW);
echoTime = pulseIn(echo, HIGH, 30000); //use the pulsein command to see how long it takes for the
//pulse to bounce back to the sensor
calculatedDistance = echoTime / 148.0; //calculate the distance of the object that reflected the pulse
// (half the bounce time multiplied by the speed of sound)
return calculatedDistance; //send back the distance that was calculated
}

